<?php if (!defined('PARENT')) { die('403'); } ?>
<!DOCTYPE html>
<html lang="en" dir="<?php echo $lang_dir; ?>">
    <head>
        <meta charset="<?php echo $charset; ?>">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
        <title><?php echo $pageTitle; ?></title>
        <link href="content/css/styles.css" rel="stylesheet">
        <?php
        // Data tables loaded
        if (defined('DATA_TABLE')) {
        ?>
        <link href="content/css/dataTables.css" rel="stylesheet" crossorigin="anonymous">
        <link href="content/css/dataTables.bootstrap4.min.css" rel="stylesheet" crossorigin="anonymous">
        <?php
        }
        // jQuery UI
        if (isset($calendarLoad)) {
        ?>
        <link href="content/js/jquery-ui/jquery-ui.min.css" rel="stylesheet">
        <?php
        }
        //Wysiwyg editor
        if (isset($wysiwygLoad)) {
        ?>
        <link href="content/css/trumbowyg.css" rel="stylesheet">
        <?php
        }
        ?>
        <link rel="icon" href="content/images/favicon.ico">
    </head>

    <body class="sb-nav-fixed<?php echo ($SETTINGS->menu == 'closed' ? ' sb-sidenav-toggled' : ''); ?>">
        <nav class="sb-topnav navbar navbar-expand">
            <a class="navbar-brand" href="index.php"><?php echo $header; ?></a>
            <button class="btn btn-link btn-sm order-1 order-lg-0" id="sidebarToggle" href="#" onclick="jsMenu()"><i class="fas fa-bars"></i></button>
            <!-- Navbar Search-->
            <form class="d-none d-md-inline-block form-inline ml-auto mr-0 mr-md-3 my-2 my-md-0" action="index.php" method="get">
                <div class="input-group">
                    <?php
                    if ($cmd=='comments' && isset($_GET['recipe'])) {
                    ?>
                    <input type="hidden" name="recipe" value="<?php echo (int) $_GET['recipe']; ?>" />
                    <?php
                    }
                    ?>
                    <input type="hidden" name="p" value="<?php echo ($cmd=='comments' ? 'comments' : 'recipes'); ?>">
                    <input class="form-control" type="text" name="q" placeholder="<?php echo ($cmd=='comments' ? $header11 : $header10); ?>" aria-label="Search" aria-describedby="basic-addon2" value="<?php echo (isset($_GET['q']) ? $_GET['q'] : ''); ?>">
                    <div class="input-group-append">
                        <button class="btn btn-primary" type="submit"><i class="fas fa-search"></i></button>
                    </div>
                </div>
            </form>
            <!-- Navbar-->
            <ul class="navbar-nav ml-auto ml-md-0">
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" id="userDropdown" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="fas fa-user fa-fw"></i></a>
                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="userDropdown">
                        <a class="dropdown-item" href="?p=settings"><i class="fas fa-cog fa-fw"></i> <?php echo $header4; ?></a>
                        <div class="dropdown-divider"></div>
                        <a class="dropdown-item" href="?p=logout"><i class="fas fa-sign-out-alt fa-fw"></i> <?php echo $header6; ?></a>
                    </div>
                </li>
            </ul>
        </nav>
        <div id="layoutSidenav">
            <div id="layoutSidenav_nav">
                <nav class="sb-sidenav accordion sb-sidenav-light" id="sidenavAccordion">
                    <div class="sb-sidenav-menu">
                        <div class="nav">
                            <div class="sb-sidenav-menu-heading"><?php echo $header5; ?></div>
                            <a class="nav-link" href="?p=cats">
                                <div class="sb-nav-link-icon"><i class="fas fa-hamburger"></i></div>
                                <?php echo $header9; ?> (<?php echo number_format(_mmSQLRows('categories')); ?>)
                            </a>
                            <a class="nav-link" href="?p=recipes">
                                <div class="sb-nav-link-icon"><i class="fas fa-utensils"></i></div>
                                <?php echo $header3; ?> (<?php echo number_format(_mmSQLRows('recipes',' WHERE isApproved = \'no\'')); ?>)
                            </a>
                            <a class="nav-link" href="?p=add">
                                <div class="sb-nav-link-icon"><i class="fas fa-plus"></i></div>
                                <?php echo $recipes7; ?>
                            </a>
                            <div class="sb-sidenav-menu-heading"><?php echo $header12; ?></div>
                            <a class="nav-link" href="?p=approve-recipes">
                                <div class="sb-nav-link-icon"><i class="fas fa-pizza-slice"></i></div>
                                <?php echo $home8; ?> (<?php echo number_format(_mmSQLRows('recipes',' WHERE isApproved = \'yes\'')); ?>)
                            </a>
                            <a class="nav-link" href="?p=approve-comments">
                                <div class="sb-nav-link-icon"><i class="fas fa-comments"></i></div>
                                <?php echo $home10; ?> (<?php echo number_format(_mmSQLRows('comments',' WHERE isApproved = \'yes\'')); ?>)
                            </a>
                        </div>
                    </div>
                </nav>
            </div>
            <div id="layoutSidenav_content">