<?php

/* ADMIN CP
==============================================*/

header('Expires: Sun, 01 Jan 2014 00:00:00 GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');
header('Content-type: text/html; charset=utf-8');
if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false)) {
  header('X-UA-Compatible: IE=edge,chrome=1');
}

// Set paths/options..
define('PATH', __dir__.'/');
define('IPATH', __dir__ . '/../');
define('PARENT', 1);

// Check cfg
if (!file_exists(IPATH . 'control/_cfg.php')) {
  die('Config file missing, please read installation instructions');
}

// Session
$ini_get = ini_get_all();
if (isset($ini_get['session.cookie_httponly'])) {
  ini_set('session.cookie_httponly', 1);
}
session_start();

include(IPATH . 'control/_cfg.php');
date_default_timezone_set((TIMEZONE ? TIMEZONE: (function_exists('date_default_timezone_get') ? date_default_timezone_get() : 'Europe/London')));

if (version_compare(phpversion(), '7.0', '<')) {
  die('PHP version too old, PHPv7 or higher required');
}

// Enable debugger
echo (!function_exists('json_decode') ? die('The JSON functions are not enabled on your server. Enable and restart server. If you are unsure please contact your host.') : '');

include(IPATH . 'control/options.php');
if (version_compare(PHP_VERSION, '8.0.0') >= 0) {
  include(IPATH . 'control/lib/tracy/vendor/tracy/tracy/src/tracy.php');
}
use Tracy\Debugger;
if (version_compare(PHP_VERSION, '8.0.0') >= 0) {
  // For development, report everything and enable tracy bar
  Debugger::$showBar = (defined('DEVELOPMENT_ENV') ? true : false);
  Debugger::$strictMode = (defined('DEVELOPMENT_ENV') ? true : false);
  Debugger::enable(Debugger::DEVELOPMENT, IPATH . 'logs');
}

include(IPATH . 'control/functions.php');
include(PATH . 'control/functions.php');
include(PATH . 'control/classes/class.categories.php');
include(PATH . 'control/classes/class.recipes.php');
include(PATH . 'control/classes/class.system.php');
include(IPATH . 'control/classes/mailer/class.mail.php');
include(IPATH . 'control/classes/class.json.php');
include(IPATH . 'control/classes/class.mobile-detection.php');
include(IPATH . 'control/classes/class.tags.php');

// Load Settings Data..
$q = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "settings` LIMIT 1");
if ($q) {
  $SETTINGS = mysqli_fetch_object($q);
  if (!isset($SETTINGS->language)) {
    header("Location: ../install/index.php");
    exit;
  }
  if (!isset($SETTINGS->smtp_fname)) {
    die('Your database is not running the latest version, try the upgrade option in the docs');
  }
} else {
  header("Location: ../install/index.php");
  exit;
}

// Load language file..
include(IPATH . 'content/lang/' . ($SETTINGS->language ? $SETTINGS->language : 'english.php'));

// Initialise vars..
$cmd                 = (isset($_GET['p']) ? (string) $_GET['p'] : 'home');
$pageTitle           = $script.' '.$script2.' '.$header;
$count               = 0;

// Create class objects..
$MRMAIL              = new mmMailer();
$PDTC                = new Detection\MobileDetect();
$MRMAIL->smtp_en     = $SETTINGS->smtp;
$MRMAIL->smtp_host   = $SETTINGS->smtp_host;
$MRMAIL->smtp_user   = $SETTINGS->smtp_user;
$MRMAIL->smtp_pass   = $SETTINGS->smtp_pass;
$MRMAIL->smtp_port   = $SETTINGS->smtp_port;
$MRMAIL->smtp_fname  = $SETTINGS->smtp_fname;
$MRMAIL->smtp_femail = $SETTINGS->smtp_femail;
$MRMAIL->addTag('{WEBSITE_NAME}',$SETTINGS->website);
$MRMAIL->addTag('{WEBSITE_URL}',$SETTINGS->install_path);
$MRMAIL->addTag('{WEBSITE_EMAIL}',$SETTINGS->email);
$MRMAIL->addTag('{DATE}',date(PHP_DATE_FORMAT,strtotime(SERVER_TIME_ADJUSTMENT)));

// CSRF Token
if (!isset($_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)])) {
  $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)] = _mmToken();
}

// Ajax
if (isset($_GET['aj'])) {
  include(PATH . 'control/ajax.php');
  exit;
}

// Platform detection
define('MSW_PFDTCT', ($PDTC->isMobile() ? ($PDTC->isTablet() ? 'tablet' : 'mobile') : 'pc'));

switch ($cmd) {
  case "home":

    isWebmasterLoggedIn();

    // Run some security checks..
    $sec = [];
    if (is_dir(IPATH . 'install/')) {
      $sec[] = $script18;
    }
    if (SECRET_KEY == 'mr-recipe-key') {
      $sec[] = $script20;
    }
    if (COOKIE_NAME == 'mr-recipe-cookie') {
      $sec[] = $script19;
    }

    $iBoxLoad = true;
    
    include(PATH . 'content/header.php');
    include(PATH . 'content/home.php');
    include(PATH . 'content/footer.php');
    break;

  case "cats":

    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      cats::add();
      $OK = true;
    }

    if (isset($_POST['edit'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      cats::update();
      $OK2 = true;
    }

    if (isset($_POST['del'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      if (!empty($_POST['cats'])) {
        cats::delete($SETTINGS);
        $OK3 = true;
      }
    }

    $pageTitle = $header9.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/cats.php');
    include(PATH . 'content/footer.php');
    break;

  case "add":

    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      if ($_POST['name'] && $_POST['ingredients'] && $_POST['instructions']) {
        // Add new recipe..
        $newID = recipes::add();
        // Upload images..
        if ($newID > 0) {
          for ($i=0; $i<count($_FILES['image']['tmp_name']); $i++) {
            $temp = $_FILES['image']['tmp_name'][$i];
            $name = $_FILES['image']['name'][$i];
            $size = $_FILES['image']['size'][$i];
            if ($temp && $name && $size > 0) {
              recipes::pictures_add(
                $name,
                $temp,
                $newID,
                $SETTINGS
              );
            }
          }
        }
        $OK = true;
      } else {
        header("Location ?p=add");
        exit;
      }
    }

    $wysiwygLoad = true;
    $pageTitle = $header2.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/add.php');
    include(PATH . 'content/footer.php');
    break;

  case "edit":

    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      recipes::update();
      $OK = true;
    }

    $calendarLoad  = 'addDate';
    $wysiwygLoad = true;
    $pageTitle     = $edit.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/edit.php');
    include(PATH . 'content/footer.php');
    break;

    case "approve-comments":

    define('DATA_TABLE', 'dataTable'); 
    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_POST['approve'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)] && in_array($_POST['approve'], ['yes','no'])) {
      if (!empty($_POST['com'])) {
        foreach ($_POST['com'] AS $comID) {
          // Send e-mails..
          if ($_POST['email'] == 'yes') {
            $COMMENT = _mmSQLTable('comments','id',$comID);
            if (isset($COMMENT->id)) {
              $RECIPE  = _mmSQLTable('recipes','id',$COMMENT->recipe);
              if (isset($RECIPE->name) && _mmEmail($RECIPE->email)) {
                $MRMAIL->addTag('{NAME}', $COMMENT->leftBy);
                $MRMAIL->addTag('{COMMENT}', $COMMENT->comment);
                $MRMAIL->addTag('{TITLE}', $RECIPE->name);
                if ($SETTINGS->modr == 'yes') {
                  $MRMAIL->addTag('{URL}', $SETTINGS->install_path . 'free-recipe/' . _mmURL($RECIPE->name) . '/' . $RECIPE->id . '/index.html');
                } else {
                  $MRMAIL->addTag('{URL}', $SETTINGS->install_path . '?p=recipe&recipe=' . $RECIPE->id);
                }
                $MRMAIL->sendMail(
                  $COMMENT->leftBy,
                  $COMMENT->email,
                  $SETTINGS->website,
                  $SETTINGS->email,
                  '['.$SETTINGS->website.'] '.($_POST['approve'] == 'yes' ? $comments28 : $comments29),
                  $MRMAIL->template(IPATH . 'content/lang/email/'.($_POST['approve'] == 'yes' ? 'comments-approved.txt' : 'comments-rejected.txt'))
                );
              }
            }
          }
        }
        if ($_POST['approve'] == 'yes') {
          recipes::comments_activate();
          $OK = true;
        } else {
          recipes::comments_reject();
          $OK2 = true;
        }
      } else {
        header("Location: ?p=approve-comments");
        exit;
      }
    }

    $iBoxLoad = true;
    $pageTitle   = $recipes11.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/approve-comments.php');
    include(PATH . 'content/footer.php');
    break;

  case "edit-comment":

    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      recipes::comments_update();
      $OK = true;
    }
    
    $calendarLoad = 'addDate';
    $pageTitle   = $comments14.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/edit-comment.php');
    include(PATH . 'content/footer.php');
    break;

  case "comments":

    define('DATA_TABLE', 'dataTable'); 
    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      if(!empty($_POST['del'])) {
        recipes::comments_delete();
        $OK = true;
      } else {
        header("Location: ?p=comments&recipe=" . (int) $_GET['recipe']);
        exit;
      }
    }

    if (isset($_GET['view'])) {
      define('WIN_LOADER', 1);
      include(PATH . 'content/view-comment.php');
      exit;
    }

    $iBoxLoad = true;
    $pageTitle   = $recipes41.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/comments.php');
    include(PATH . 'content/footer.php');
    break;

  case "approve-recipes":

    define('DATA_TABLE', 'dataTable'); 
    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_POST['approve'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)] && in_array($_POST['approve'], ['yes','no'])) {
      if (!empty($_POST['rec'])) {
        foreach ($_POST['rec'] AS $recID) {
          // Send e-mails..
          if ($_POST['email'] == 'yes') {
            $RECIPE  = _mmSQLTable('recipes','id',$recID);
            if (isset($RECIPE->name) && _mmEmail($RECIPE->email)) {
              $MRMAIL->addTag('{NAME}', $RECIPE->submitted_by);
              $MRMAIL->addTag('{TITLE}', $RECIPE->name);
              if ($SETTINGS->modr == 'yes') {
                $MRMAIL->addTag('{URL}', $SETTINGS->install_path . 'free-recipe/' . _mmURL($RECIPE->name) . '/' . $RECIPE->id . '/index.html');
              } else {
                $MRMAIL->addTag('{URL}', $SETTINGS->install_path . '?p=recipe&recipe=' . $RECIPE->id);
              }
              $MRMAIL->sendMail(
                $RECIPE->submitted_by,
                $RECIPE->email,
                $SETTINGS->website,
                $SETTINGS->email,
                '['.$SETTINGS->website.'] '.($_POST['approve'] == 'yes' ? $recipes47 : $recipes48),
                $MRMAIL->template(IPATH . 'content/lang/email/'.($_POST['approve'] == 'yes' ? 'recipe-approved.txt' : 'recipe-rejected.txt'))
              );
            }
          }
        }
        if ($_POST['approve'] == 'yes') {
          recipes::recipe_activate();
          $OK = true;
        } else {
          recipes::recipe_reject($SETTINGS);
          $OK2 = true;
        }
      } else {
        header("Location: ?p=approve-recipes");
        exit;
      }
    }

    $pageTitle = $recipes14.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/approve-recipes.php');
    include(PATH . 'content/footer.php');
    break;

  case "pictures":

    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      $imgRun = 0;
      for ($i=0; $i<count($_FILES['image']['tmp_name']); $i++) {
        $name = $_FILES['image']['name'][$i];
        $temp = $_FILES['image']['tmp_name'][$i];
        $size = $_FILES['image']['size'][$i];
        if ($name && $temp && $size > 0) {
          recipes::pictures_add(
            $name,
            $temp,
            (int)$_GET['recipe'],
            $SETTINGS
          );
          ++$imgRun;
        }
      }
      if ($imgRun>0) {
        $OK = true;
      } else {
        header("Location: index.php?p=pictures");
        exit;
      }
    }

    if (isset($_POST['del'],$_POST['pics'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      recipes::pictures_delete($SETTINGS);
      $OK2 = true;
    }

    // Load iBox..
    $iBoxLoad = true;
    $pageTitle = $recipes34.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/pictures.php');
    include(PATH . 'content/footer.php');
    break;

  case "settings":

    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      settings::update();
      $OK = true;
    }

    $pageTitle = $header4.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/settings.php');
    include(PATH . 'content/footer.php');
    break;

  case "recipes":

    define('DATA_TABLE', 'dataTable'); 
    isWebmasterLoggedIn();

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
      $_POST['csrf'] == $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)]) {
      if (!empty($_POST['del'])) {
        recipes::delete($SETTINGS);
        $OK = true;
      } else {
        header("Location: index.php?p=recipes");
        exit;
      }
    }

    $pageTitle = $header3.': '.$pageTitle;

    include(PATH . 'content/header.php');
    include(PATH . 'content/recipes.php');
    include(PATH . 'content/footer.php');
    break;

  case "login":

    isWebmasterLoggedIn(true);

    if (isset($_POST['process'],$_POST['csrf'],$_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)])) {
      if ($_POST['user'] && $_POST['pass'] && $_SESSION['atoken_' . sha1($SETTINGS->email . SECRET_KEY)] == $_POST['csrf']) {
        if ($_POST['user'] != USERNAME) {
          $U_ERROR = true;
          $count++;
        }
        if (_mmEncrypt(SECRET_KEY . $_POST['pass']) != _mmEncrypt(SECRET_KEY . PASSWORD)) {
          $P_ERROR = true;
          $count++;
        }
        if ($count==0) {
          // Set session var..
          $_SESSION[_mmEncrypt(SECRET_KEY)] = _mmEncrypt(SECRET_KEY.$_POST['user']);
          // Set cookie..
          if (isset($_POST['cookie'])) {
            setcookie(_mmEncrypt(SECRET_KEY . COOKIE_NAME), _mmEncrypt(SECRET_KEY . $_POST['user']), time() + 60*60*24*30);
          }
          header("Location: index.php");
          exit;
        }
      } else {
        header("Location: index.php?p=login");
        exit;
      }
    }

    include(PATH . 'content/login.php');
    break;

  case "logout":

    session_unset();
    session_destroy();
    setcookie('PHPSESSID', 0, time() - 3600);
    unset($_SESSION[_mmEncrypt(SECRET_KEY)]);
    unset($_SESSION);
    if (isset($_COOKIE[_mmEncrypt(SECRET_KEY.COOKIE_NAME)])) {
      setcookie(_mmEncrypt(SECRET_KEY.COOKIE_NAME),'');
      unset($_COOKIE[_mmEncrypt(SECRET_KEY.COOKIE_NAME)]);
    }
    header("Location: index.php?p=login");

    break;
}

?>
