<?php if (!defined('PARENT')) { exit; } ?>
<!DOCTYPE html>
<html lang="en" dir="<?php echo $this->DIR; ?>">
    <head>
      <meta charset="<?php echo $this->CHARSET; ?>">
      <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
      <meta name="description" content="<?php echo $this->META_DESC; ?>">
      <meta name="keywords" content="<?php echo $this->META_KEYS; ?>">
      
      <title><?php echo $this->TITLE; ?></title>
      <base href="<?php echo $this->BASE_PATH; ?>">
      
      <link rel="icon" type="image/x-icon" href="content/images/favicon.ico">
      <link rel="stylesheet" href="content/css/normalize.css" type="text/css">
      <link rel="stylesheet" href="content/css/animate.css" type="text/css">
      <link href="content/css/bootstrap.css" rel="stylesheet">
      <link href="content/css/font-awesome/fontawesome.css" rel="stylesheet">
      <link href="content/css/theme.css" rel="stylesheet">
      <link rel="stylesheet" href="content/css/plugins.css" type="text/css">
      <link rel="stylesheet" href="content/css/mobile.css" type="text/css">
      <link rel="stylesheet" href="content/css/splide.min.css" type="text/css">
      <link rel="stylesheet" href="content/css/splide-skyblue.min.css" type="text/css">
      <?php
      // Loads RSS meta link if enabled..
      echo $this->RSS_HEAD_LINK;
      // Facebook open graph tag for recipes..
      if (!empty($this->OG_DATA)) {
        ?>
        <meta property="og:type" content="website">
        <meta property="og:url" content="<?php echo $this->OG_DATA['url']; ?>">
        <meta property="og:description" content="<?php echo $this->META_DESC; ?>">
        <meta property="og:site_name" content="<?php echo $this->TITLE2; ?>">
        <?php
        // For SSL connections
        if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
          ?>
          <meta property="og:image:secure_url" content="<?php echo $this->OG_DATA['name']; ?>">
          <?php
        }
        ?>
        <meta property="og:title" content="<?php echo $this->OG_DATA['name']; ?>">
        <?php
        // Is image data available?
        if (isset($this->OG_DATA['sizes'][1],$this->OG_DATA['sizes'][0])) {
        ?>
        <meta property="og:image" content="<?php echo $this->OG_DATA['pic']; ?>">
        <meta property="og:image:height" content="<?php echo $this->OG_DATA['sizes'][1]; ?>">
        <meta property="og:image:width" content="<?php echo $this->OG_DATA['sizes'][0]; ?>">
        <meta property="fb:app_id" content="0">
        <?php
        }
      }
      ?>
      </head>
    <body>
        
      <div class="navbar">
        <div class="navbar-inner">
          <div class="container">
            <div class="row">
              <div class="col-lg-7 col-md-6 col-sm-6 col-xs-5 leftblock">
                <a href="<?php echo $this->H_URL; ?>"><i class="fas fa-utensils fa-fw"></i> <?php echo $this->TITLE2; ?></a>
              </div>
              <div class="col-lg-5 col-md-6 col-sm-6 col-xs-7 links">
                <a href="<?php echo $this->H_URL; ?>"><i class="fas fa-home fa-fw"></i><span class="hidden-xs"> <?php echo strtoupper($this->HOME); ?></span></a>
                <?php
                // Add recipe enabled?
                if ($this->SETTINGS->addRecipe == 'yes') {
                ?>
                <a href="<?php echo $this->A_URL; ?>"><i class="fas fa-plus-circle fa-fw"></i><span class="hidden-xs"> <?php echo strtoupper($this->ADD_RECIPE); ?></span></a>
                <?php
                }
                ?>
                <a href="<?php echo $this->AB_URL; ?>"><i class="fas fa-info-circle fa-fw"></i><span class="hidden-xs"> <?php echo strtoupper($this->ABOUT_US); ?></span></a>
                <a href="<?php echo $this->C_URL; ?>"><i class="fas fa-envelope fa-fw"></i><span class="hidden-xs"> <?php echo strtoupper($this->CONTACT_US); ?></span></a>
              </div>
            </div>
          </div>
        </div>
      </div>