<?php if (!defined('PARENT') || !isset($this->RECIPE->name)) { exit; } ?>
<!DOCTYPE html>
<html lang="en">
    <head>
      <meta charset="<?php echo $this->CHARSET; ?>">
      <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
      <title><?php echo _mmHTML($this->RECIPE->name); ?></title>
      <base href="<?php echo $this->BASE_PATH; ?>">
      
      <link rel="icon" type="image/x-icon" href="content/images/favicon.ico">
      <link href="content/css/bootstrap.css" rel="stylesheet">
      <link href="content/css/font-awesome/fontawesome.css" rel="stylesheet">
      <link href="content/css/theme.css" rel="stylesheet">
    </head>

    <body>

    <div>

      <div class="container">
        <div class="row">
          <div class="col-lg-12">
            <h1>
              <br><?php echo _mmHTML($this->RECIPE->name); ?>
              <span><?php echo $this->DATE_BAR_TXT; ?></span>
            </h1>
            
            <?php
            if ($this->RECIPE->ingredients) {
            ?>
            <h2><i class="fas fa-cookie-bite fa-fw"></i> <?php echo $this->INGREDIENTS_TXT; ?></h2>
            
            <div class="panel panel-default">
              <div class="panel-body ingredients">
                <?php 
                // As carriage returns convert to line breaks, we can remove html ones that are escaped
                echo str_replace('&lt;br&gt;','',nl2br(_mmHTML($this->RECIPE->ingredients)));
                ?>
              </div>
            </div>
            <?php
            }
            
            if ($this->RECIPE->instructions) {
            ?>
            <h2><i class="fas fa-book fa-fw"></i> <?php echo $this->INSTRUCTIONS_TXT; ?></h2>
            
            <div class="panel panel-default">
              <div class="panel-body">
                <?php
                // As carriage returns convert to line breaks, we can remove html ones that are escaped
                echo str_replace('&lt;br&gt;','',nl2br(_mmHTML($this->RECIPE->instructions)));
                ?>
              </div>
            </div>
            <?php
            }
            ?>
            
            <hr>
            
            <div class="panel panel-default">
              <div class="panel-body print_foot">
                <?php echo $this->BY; ?>
              </div>
            </div>
            
          </div>
        </div>
      </div>

    </div>
    
    <script src="content/js/jquery.js"></script>
    <script>
    //<![CDATA[
    jQuery(document).ready(function() {
      window.print();
    });
    //]]>
    </script>

    </body>
    
</html>
