<?php

/* AJAX Processor
------------------------------*/

if (!defined('PARENT') || !isset($_GET['aj']) || !isset($_POST['csrf'])) {
  exit;
}

// Defaults
$json = [
  'txt' => $vars[0],
  'msg' => $vars[1],
  'status' => 'err'
];

switch($_GET['aj']) {
  case 'add':
    if ($SETTINGS->addRecipe == 'yes') {
      $allow = 'yes';
      $img_ok = [];
      $_POST  = _mmMDAM('_mmHTML', $_POST);
      // Check for security credentials
      if ($SETTINGS->a_user && $SETTINGS->a_pass && !isset($_SESSION[$lKey])) {
        $allow = 'no';
      }
      if ($allow == 'yes') {
        $fm = [
          'name' => (isset($_POST['nm']) ? $_POST['nm'] : ''),
          'email' => (isset($_POST['em']) && _mmEmail($_POST['em']) ? $_POST['em'] : ''),
          'recipe' => (isset($_POST['rn']) ? $_POST['rn'] : ''),
          'cats' => (!empty($_POST['cats']) ? $_POST['cats'] : []),
          'ingredients' => (isset($_POST['ingredients']) ? $_POST['ingredients'] : ''),
          'instructions' => (isset($_POST['instructions']) ? $_POST['instructions'] : ''),
          'images' => [
            'names' => ($SETTINGS->maxImages > 0 && !empty($_FILES['img']['name']) ? $_FILES['img']['name'] : []),
            'tmp' => ($SETTINGS->maxImages > 0 && !empty($_FILES['img']['tmp_name']) ? $_FILES['img']['tmp_name'] : []),
            'size' => ($SETTINGS->maxImages > 0 && !empty($_FILES['img']['size']) ? $_FILES['img']['size'] : [])
          ],
          'code' => (isset($_POST['code']) ? $_POST['code'] : ''),
          'csrf' => (isset($_POST['csrf']) ? $_POST['csrf'] : '')
        ];
        if (isset($_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
          $_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)] == $fm['csrf']) {
          if ($fm['name'] == '') {
            $formErrors[] = $ps_contact;
          }
          if ($fm['email'] == '') {
            $formErrors[] = $ps_contact2;
          }
          if ($fm['recipe'] == '') {
            $formErrors[] = $ps_addrecipe21;
          }
          if ($fm['ingredients'] == '') {
            $formErrors[] = $ps_addrecipe15;
          }
          if ($fm['instructions'] == '') {
            $formErrors[] = $$ps_addrecipe16;
          }
          if (empty($fm['cats'])) {
            $formErrors[] = $vars[14];
          }
          if ($SETTINGS->enSpam == 'yes' && !isset($_SESSION[$lKey])) {
            if ($fm['code'] == '' || $fm['code'] != captcha::check()) {
              $formErrors[] = $ps_contact4;
            }
          }
          if (!empty($fm['images']['tmp'])) {
            for($i=0; $i<count($fm['images']['tmp']); $i++) {
              if ($fm['images']['tmp'][$i] && is_uploaded_file($fm['images']['tmp'][$i]) && $fm['images']['size'][$i] > 0) {
                $finfo = new finfo(FILEINFO_MIME_TYPE);
                $mime  = $finfo->file($fm['images']['tmp'][$i]);
                // Check mime
                if (!in_array($mime, $allowedMimeTypes)) {
                  $formErrors[] = str_replace('{file}',_mmHTML($fm['images']['names'][$i]),$vars[15]);
                  unlink($fm['images']['tmp'][$i]);
                } elseif ($SETTINGS->maxFileSize > 0 && $fm['images']['size'][$i] > $SETTINGS->maxFileSize) {
                  $formErrors[] = str_replace(
                    ['{file}','{size}'],
                    [_mmHTML($fm['images']['names'][$i]),_mmFileConv($SETTINGS->maxFileSize)],
                    $vars[16]
                  );
                  unlink($fm['images']['tmp'][$i]);
                } else {
                  if ($fm['images']['size'][$i] > 0) {
                    $img_ok[] = [
                      'tmp' => $fm['images']['tmp'][$i],
                      'name' => recipes::upload_name_filter($fm['images']['names'][$i]),
                      'size' => $fm['images']['size'][$i]
                    ];
                  }
                }
              }
            }
          }
          if (!empty($formErrors)) {
            $json['msg'] = implode('<br>', $formErrors);
          } else {
            // Add
            $count = 0;
            $newID = recipes::recipe_add($fm,$SETTINGS);
            // Upload images..
            if (!empty($img_ok)) {
              for ($i=0; $i<count($img_ok); $i++) {
                recipes::recipe_pic_upload(
                  $img_ok[$i]['tmp'],
                  $img_ok[$i]['name'],
                  $img_ok[$i]['size'],
                  $newID,
                  $SETTINGS
                );
                ++$count;
              }
            }
            // Send e-mails..
            foreach (['name','email','recipe','ingredients','instructions'] AS $key) {
              $MRMAIL->addTag('{' . strtoupper($key) . '}',$fm[$key]);
            }
            $thecats = categories::category_names($fm['cats']);
            $MRMAIL->addTag('{CATS}', (!empty($thecats) ? implode(', ', $thecats) : ''));
            $MRMAIL->addTag('{IMG_COUNT}', $count);
            // Get recipe url
            $url = '';
            $RECIPE = _mmSQLTable('recipes','id',$newID);
            if (isset($RECIPE->id)) {
              if ($SETTINGS->modr == 'yes') {
                $url  = $SETTINGS->install_path . 'free-recipe/' . _mmURL($RECIPE->name) . '/' . $RECIPE->id . '/index.html';
              } else {
                $url  = $SETTINGS->install_path . '?p=recipe&recipe=' . $RECIPE->id;
              }
            }
            $MRMAIL->addTag('{LINK}', $url);
            // Send to webmaster..
            $MRMAIL->sendMail(
              $SETTINGS->website,
              $SETTINGS->email,
              $fm['name'],
              $fm['email'],
              '['.$SETTINGS->website.'] ' . $ps_addrecipe22,
              $MRMAIL->template(PATH . 'content/lang/email/new-recipe.txt')
            );
            // Send auto responder if enabled..
            if (ENABLE_RECIPE_AUTO_RESPONDER) {
              $MRMAIL->sendMail(
                $fm['name'],
                $fm['email'],
                $SETTINGS->website,
                $SETTINGS->email,
                '['.$SETTINGS->website.'] ' . $ps_addrecipe23,
                $MRMAIL->template(PATH . 'content/lang/email/auto-recipe'.($SETTINGS->enRecApp=='yes' ? '-approve' : '').'.txt')
              );
            }
            // Clear temp data if left behind
            if (!empty($fm['images']['tmp'])) {
              for($i=0; $i<count($fm['images']['tmp']); $i++) {
                if (file_exists($fm['images']['tmp'][$i])) {
                  unlink($fm['images']['tmp'][$i]);
                }
              }
            }
            $json['status'] = 'ok';
            $json['txt'] = $ps_addrecipe18;
            $json['msg'] = str_replace(['{website_name}','{url}'],[_mmHTML($SETTINGS->website),$url],($SETTINGS->enRecApp=='yes' ? $ps_addrecipe19 : $ps_addrecipe20));
          }
        }
      }
    }
    break;
  case 'login':
    $_POST  = _mmMDAM('_mmHTML', $_POST);
    $fm = [
      'name' => (isset($_POST['nm']) ? $_POST['nm'] : ''),
      'pass' => (isset($_POST['pw']) ? $_POST['pw'] : ''),
      'code' => (isset($_POST['code']) ? $_POST['code'] : ''),
      'csrf' => (isset($_POST['csrf']) ? $_POST['csrf'] : '')
    ];
    if ($SETTINGS->addRecipe == 'yes' && $SETTINGS->a_user && $SETTINGS->a_pass) {
      if (isset($_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
        $_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)] == $fm['csrf']) {
          if ($fm['name'] == '' || $fm['pass'] == '') {
            $formErrors[] = $vars[11];
          }
          if ($SETTINGS->enSpam == 'yes') {
            if ($fm['code'] == '' || $fm['code'] != captcha::check()) {
              $formErrors[] = $ps_contact4;
            }
          }
          if (!empty($formErrors)) {
            $json['msg'] = implode('<br>', $formErrors);
          } else {
            if ($fm['name'] == $SETTINGS->a_user && mmHash(array('type' => 'calc', 'val' => $fm['pass'], 'hash' => $SETTINGS->a_pass))) {
              $json['status'] = 'ok';
              $_SESSION[$lKey] = _mmEncrypt($SETTINGS->email . SECRET_KEY . time());
            } else {
              $json['msg'] = $vars[11];
            }
          }
        }
    }
    break;
  case 'comments':
    $_POST  = _mmMDAM('_mmHTML', $_POST);
    $fm = [
      'name' => (isset($_POST['nm']) ? $_POST['nm'] : ''),
      'email' => (isset($_POST['em']) && _mmEmail($_POST['em']) ? $_POST['em'] : ''),
      'comments' => (isset($_POST['comments']) ? $_POST['comments'] : ''),
      'recipe' => (isset($_POST['recipe']) ? (int) $_POST['recipe'] : '0'),
      'code' => (isset($_POST['code']) ? $_POST['code'] : ''),
      'csrf' => (isset($_POST['csrf']) ? $_POST['csrf'] : '')
    ];
    if (ENABLE_RECIPE_COMMENT_ADDING && isset($_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
        $_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)] == $fm['csrf'] &&
        $fm['recipe'] > 0) {
      $RECIPE = _mmSQLTable('recipes','id',$fm['recipe']);
      if (isset($RECIPE->enComments) && $RECIPE->enComments == 'yes') {
        if ($fm['name'] == '') {
          $formErrors[] = $ps_contact;
        }
        if ($fm['email'] == '') {
          $formErrors[] = $ps_contact2;
        }
        if ($fm['comments'] == '') {
          $formErrors[] = $ps_contact3;
        }
        if ($SETTINGS->enSpam == 'yes') {
          if ($fm['code'] == '' || $fm['code'] != captcha::check()) {
            $formErrors[] = $ps_contact4;
          }
        }
        if (!empty($formErrors)) {
          $json['msg'] = implode('<br>', $formErrors);
        } else {
          $ID = recipes::comments_add($fm,$SETTINGS);
          if ($ID > 0) {
            foreach ($fm AS $key => $value) {
              $MRMAIL->addTag('{' . strtoupper($key) . '}', $value);
            }
            $MRMAIL->addTag('{TITLE}', $RECIPE->name);
            $MRMAIL->addTag('{CHEF}', $RECIPE->submitted_by);
            // Send to webmaster..
            $MRMAIL->sendMail(
              $SETTINGS->website,
              $SETTINGS->email,
              $fm['name'],
              $fm['email'],
              '[' . $SETTINGS->website . '] ' . $ps_recipe37,
              $MRMAIL->template(PATH . 'content/lang/email/new-comment.txt')
            );
            // Send auto responder if enabled..
            if (ENABLE_COMMENT_AUTO_RESPONDER) {
              $MRMAIL->sendMail(
                $fm['name'],
                $fm['email'],
                $SETTINGS->website,
                $SETTINGS->email,
                '[' . $SETTINGS->website . '] ' . $ps_recipe38,
                $MRMAIL->template(PATH . 'content/lang/email/auto-comments' . ($SETTINGS->enCommApp=='yes' ? '-approve' : '').'.txt')
              );
            }
            $json['status'] = 'ok';
            $json['txt'] = $ps_contact18;
            $json['msg'] = str_replace('{recipe}',_mmHTML($RECIPE->name),($SETTINGS->enCommApp=='yes' ? $jsvars71 : $jsvars70));
          }
        }
      }
    }
    break;
  case 'contact':
    $_POST  = _mmMDAM('_mmHTML', $_POST);
    $fm = [
      'name' => (isset($_POST['nm']) ? $_POST['nm'] : ''),
      'email' => (isset($_POST['em']) && _mmEmail($_POST['em']) ? $_POST['em'] : ''),
      'comments' => (isset($_POST['msg']) ? $_POST['msg'] : ''),
      'code' => (isset($_POST['code']) ? $_POST['code'] : ''),
      'csrf' => (isset($_POST['csrf']) ? $_POST['csrf'] : '')
    ];
    if (isset($_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)]) &&
        $_SESSION['token_' . sha1($SETTINGS->email . SECRET_KEY)] == $fm['csrf']) {
      if ($fm['name'] == '') {
        $formErrors[] = $ps_contact;
      }
      if ($fm['email'] == '') {
        $formErrors[] = $ps_contact2;
      }
      if ($fm['comments'] == '') {
        $formErrors[] = $ps_contact3;
      }
      if ($SETTINGS->enSpam == 'yes') {
        if ($fm['code'] == '' || $fm['code'] != captcha::check()) {
          $formErrors[] = $ps_contact4;
        }
      }
      if (!empty($formErrors)) {
        $json['msg'] = implode('<br>', $formErrors);
      } else {
        foreach ($fm AS $key => $value) {
          $MRMAIL->addTag('{' . strtoupper($key) . '}', $value);
        }
        // Send to webmaster..
        $MRMAIL->sendMail(
          $SETTINGS->website,
          $SETTINGS->email,
          $fm['name'],
          $fm['email'],
          '[' . $SETTINGS->website . '] ' . $ps_contact14,
          $MRMAIL->template(PATH . 'content/lang/email/webmaster.txt')
        );
        // Send auto responder if enabled..
        if (ENABLE_CONTACT_US_AUTO_RESPONDER) {
          $MRMAIL->sendMail(
            $fm['name'],
            $fm['email'],
            $SETTINGS->website,
            $SETTINGS->email,
            '[' . $SETTINGS->website . '] ' . $ps_contact15,
            $MRMAIL->template(PATH . 'content/lang/email/auto-responder.txt')
          );
        }
        $json['status'] = 'ok';
        $json['txt'] = $ps_contact12;
        $json['msg'] = str_replace('{website_name}',_mmHTML($SETTINGS->website),$ps_contact13);
      }
    }
    break;
}

echo json::encode($json);

?>