<?php

/* CLASS FILE
----------------------------------*/

class categories {

  // Displays category recipes..
  public static function category_recipes($searchKeys = '', $count = false, $s = null) {
    global $limit,$ps_category8;
    $string = '';
    $sqry = [];
    if ($searchKeys) {
      // Contributor search
      if (substr($searchKeys,0,6) == 'chef::') {
        $sqry[] = 'AND (`submitted_by` = \'' . _mmSQLSafe(substr($searchKeys,6)) . '\')';
        $sqry[] = (isset($_GET['cat']) && (int) $_GET['cat']>0 ? 'AND (`' . DB_PREFIX . 'recipe_cats`.`category` = \'' . (int) $_GET['cat'] . '\')' : '');
      } else {
        $skeys = explode(' ', $searchKeys);
        foreach($skeys AS $skeys_word) {
          if (strlen($skeys_word) > 3) {
            $sqry[] = (!empty($sqry) ? 'OR ' : 'AND ') . '(MATCH(`name`,`instructions`,`ingredients`,`submitted_by`) AGAINST(\'' . _mmSQLSafe($skeys_word) . '\' IN BOOLEAN MODE))';
            $sqry[] = (isset($_GET['cat']) && (int) $_GET['cat']>0 ? (!empty($sqry) ? 'OR ' : 'AND ') . '(`' . DB_PREFIX . 'recipe_cats`.`category` = \'' . (int) $_GET['cat'] . '\')' : '');
          } else {
            $sqry[] = (!empty($sqry) ? 'OR ' : 'AND ') . '(`name` LIKE \'%'._mmSQLSafe($skeys_word).'%\' OR `instructions` LIKE \'%'._mmSQLSafe($skeys_word).'%\' OR `ingredients` LIKE \'%' . _mmSQLSafe($skeys_word) . '%\' OR `submitted_by` LIKE \'%' . _mmSQLSafe($skeys_word) . '%\')';
            $sqry[] = (isset($_GET['cat']) && (int) $_GET['cat']>0 ? (!empty($sqry) ? 'OR ' : 'AND ') . '(`' . DB_PREFIX . 'recipe_cats`.`category` = \'' . (int) $_GET['cat'] . '\')' : '');
          }
        }
      }
    } else {
      $sqry[] = (isset($_GET['cat']) && $_GET['cat']>0 ? (!empty($sqry) ? 'OR ' : 'AND ') . '(' . DB_PREFIX . 'recipe_cats.category = \'' . (int) $_GET['cat'] . '\')' : '');
    }
    $q_recipe = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT SQL_CALC_FOUND_ROWS *,`" . DB_PREFIX . "recipes`.`id` AS `recipeID`,
                (SELECT `picPath` FROM `" . DB_PREFIX . "pictures`
                WHERE `" . DB_PREFIX . "pictures`.`recipe` = `" . DB_PREFIX . "recipes`.`id`
                ORDER BY rand() LIMIT 1
                ) AS `recPicture`,
                DATE_FORMAT(`addDate`, '" . MYSQL_DATE_FORMAT . "') AS `a_date`
                FROM `" . DB_PREFIX . "recipes`
                LEFT JOIN `" . DB_PREFIX . "recipe_cats`
                ON `" . DB_PREFIX . "recipes`.`id` = `" . DB_PREFIX . "recipe_cats`.`recipe`
                WHERE `enRecipe`  = 'yes'
                AND `isApproved`  = 'no'
                " . implode(_mmNL(), $sqry) . "
                GROUP BY `" . DB_PREFIX . "recipe_cats`.`recipe`
                ORDER BY `" . (RECIPE_DISPLAY_ORDER ? RECIPE_DISPLAY_ORDER : 'name') . "`
                LIMIT $limit," . $s->total
                ) or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    if ($count) {
      $c = mysqli_fetch_object(mysqli_query($GLOBALS["___mysqli_ston"], "SELECT FOUND_ROWS() AS `rows`"));
      return (isset($c->rows) ? $c->rows : '0');
    }
    while ($RECIPES = mysqli_fetch_object($q_recipe)) {
      $image = 'content/images/placeholder.png';
      // Build link data..
      if ($s->modr=='yes') {
        $link  = $s->install_path . 'free-recipe/' . _mmURL($RECIPES->name) . '/' . $RECIPES->recipeID . '/index.html';
      } else {
        $link  = $s->install_path . '?p=recipe&amp;recipe=' . $RECIPES->recipeID;
      }
      // For by url..
      if ($s->modr=='yes') {
        $byurl  = $s->install_path.'search-free-recipes/chef::' . urlencode($RECIPES->submitted_by) . '/all/1/index.html';
      } else {
        $byurl  = '?p=search-free-recipes&amp;keys=chef::' . urlencode($RECIPES->submitted_by) . '&amp;cat=all';
      }
      if (isset($RECIPES->recPicture) && $RECIPES->recPicture && file_exists(PATH . 'content/images/recipes/' . $RECIPES->recPicture)) {
        $image = 'content/images/recipes/' . $RECIPES->recPicture;
      }
      $string .= str_replace(
        array('{url}','{byurl}','{by}','{recipe}','{image}','{date}'),
        array($link,$byurl,_mmHTML($RECIPES->submitted_by),_mmHTML($RECIPES->name),$image,$RECIPES->a_date),
        file_get_contents(PATH.'content/html/recipe.htm')
      );
    }
    return $string;
  }

  // Get children of parent..
  public static function children($id) {
    $cats = [];
    $q = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT `id` FROM `" . DB_PREFIX . "categories`
         WHERE `enCat` = 'yes'
         AND `childOf` = '$id'
         ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    while ($C = mysqli_fetch_object($q)) {
      $cats[] = $C->id;
    }
    return $cats;
  }

  // Loads categories as a select list for search by category..
  public static function category_search_select($searchKeys,$s = null) {
    global $recipes16;
    $string   = '';
    if ($s->modr=='yes') {
      $url = $s->install_path .'search-free-recipes/' . $searchKeys . '/all/1/index.html';
    } else {
      $url = '?p=search-free-recipes&amp;keys=' . $searchKeys . '&amp;cat=all';
    }
    $string .= '<option value="' . $url . '">' . $recipes16 . '</option>'._mmNL();
    $q_parent = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                WHERE `enCat`   = 'yes'
                AND `isParent`  = 'yes'
                ORDER BY `catname`
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    while ($PARENTS = mysqli_fetch_object($q_parent)) {
      if ($s->modr=='yes') {
        $url = $s->install_path . 'search-free-recipes/' . $searchKeys . '/' . $PARENTS->id . '/1/index.html';
      } else {
        $url = '?p=search-free-recipes&amp;keys=' . $searchKeys . '&amp;cat=' . $PARENTS->id;
      }
      $string .= '<option value="' . $url . '"' . (isset($_GET['cat']) && $_GET['cat']==$PARENTS->id ? ' selected="selected"' : '') . '>' . _mmClean($PARENTS->catname) . '</option>' . _mmNL();
      $q_children = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                    WHERE `enCat` = 'yes'
                    AND `childOf` = '{$PARENTS->id}'
                    ORDER BY `catname`
                    ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
      while ($CHILDREN = mysqli_fetch_object($q_children)) {
        if ($s->modr=='yes') {
          $curl = $s->install_path.'search-free-recipes/' . urldecode($searchKeys) . '/' . $CHILDREN->id . '/1/index.html';
        } else {
          $curl = '?p=search-free-recipes&amp;keys=' . urldecode($searchKeys) . '&amp;cat=' . $CHILDREN->id;
        }
        $string .= '<option value="' . $curl . '"' . (isset($_GET['cat']) && $_GET['cat']==$CHILDREN->id ? ' selected="selected"' : '') . '>- ' . _mmClean($CHILDREN->catname) . '</option>' . _mmNL();
      }
    }
    return $string;
  }

  // Loads categories as a select list..
  public static function category_select($ids = false,$s = null) {
    $string = '';
    $q_parent = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                WHERE `enCat`   = 'yes'
                AND `isParent`  = 'yes'
                ORDER BY `catname`
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    while ($PARENTS = mysqli_fetch_object($q_parent)) {
      if ($s->modr=='yes') {
        $url = $s->install_path . 'category/' . _mmURL($PARENTS->catname) . '/' . $PARENTS->id . '/1/index.html';
      } else {
        $url = '?p=category&amp;cat=' . $PARENTS->id;
      }
      $string .= '<option value="' . ($ids ? $PARENTS->id : $url) . '"' . (isset($_POST['cat']) && $_POST['cat']==$PARENTS->id ? ' selected="selected"' : '') . '>' . _mmClean($PARENTS->catname) . '</option>' . _mmNL();
      $q_children = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                    WHERE `enCat` = 'yes'
                    AND `childOf` = '{$PARENTS->id}'
                    ORDER BY `catname`
                    LIMIT ".SUB_CATEGORY_DISPLAY_COUNT) or die(mysqli_error($GLOBALS["___mysqli_ston"]));
      while ($CHILDREN = mysqli_fetch_object($q_children)) {
        if ($s->modr=='yes') {
          $curl = $s->install_path . 'category/' . _mmURL($PARENTS->catname) . '/' . _mmURL($CHILDREN->catname) . '/' . $CHILDREN->id . '/1/index.html';
        } else {
          $curl = '?p=category&amp;cat='.$CHILDREN->id;
        }
        $string .= '<option value="' . ($ids ? $CHILDREN->id : $curl) . '"' . (isset($_POST['cat']) && $_POST['cat']==$CHILDREN->id ? ' selected="selected"' : '') . '>- ' . _mmClean($CHILDREN->catname) . '</option>' . _mmNL();
      }
    }
    return $string;
  }

  // Builds homepage category/sub category list..
  public static function build($s) {
    $left         = '';
    $right        = '';
    $run          = 0;
    $theChildren  = [];
    $q_parent = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                WHERE `enCat`   = 'yes'
                AND `isParent`  = 'yes'
                ORDER BY `catname`
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    while ($PARENTS = mysqli_fetch_object($q_parent)) {
      if (++$run%2!=0) {
        $children     = '';
        $ccount       = 0;
        $theChildren  = [];
        if ($s->modr=='yes') {
          $url = $s->install_path . 'category/' . _mmURL($PARENTS->catname) . '/' . $PARENTS->id . '/1/index.html';
        } else {
          $url = '?p=category&amp;cat=' . $PARENTS->id;
        }
        $q_children = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                      WHERE `enCat` = 'yes'
                      AND `childOf` = '{$PARENTS->id}'
                      ORDER BY `catname`
                      LIMIT " . SUB_CATEGORY_DISPLAY_COUNT
                      ) or die(mysqli_error($GLOBALS["___mysqli_ston"]));
        if (mysqli_num_rows($q_children)>0) {
          $theChildren = categories::children($PARENTS->id);
        }
        while ($CHILDREN = mysqli_fetch_object($q_children)) {
          if ($s->modr=='yes') {
            $curl = $s->install_path . 'category/' . _mmURL($PARENTS->catname) . '/' . _mmURL($CHILDREN->catname) . '/' . $CHILDREN->id . '/1/index.html';
          } else {
            $curl = '?p=category&amp;cat=' . $CHILDREN->id;
          }
          $children .= '<a href="' . $curl . '">' . _mmClean($CHILDREN->catname) . '</a>' . (SHOW_CATEGORY_RECIPE_COUNT ? ' (' . _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category = \'' . $CHILDREN->id . '\'') . ')' : '') . (++$ccount!=mysqli_num_rows($q_children) ? ', ' : (SUB_CATEGORY_DISPLAY_COUNT>mysqli_num_rows($q_children) ? '' : '...'));
        }
        $left .= str_replace(array('{url}','{parent}','{children}','{count}'),
          array($url,_mmClean($PARENTS->catname),($children ? '<span class="children">' . $children . '</span>' : ''),(SHOW_CATEGORY_RECIPE_COUNT ? ' (' . (PARENT_WITH_CHILD_COUNT ? _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category = \'' . $PARENTS->id . '\'')+(!empty($theChildren) ? _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category IN (' . implode(',',$theChildren) . ')') : 0) : _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category = \'' . $PARENTS->id . '\'')) . ')' : '')),
          file_get_contents(PATH . 'content/html/categories-list.htm')
        );
      } else {
        $children     = '';
        $ccount       = 0;
        $theChildren  = [];
        if ($s->modr=='yes') {
          $url = $s->install_path . 'category/' . _mmURL($PARENTS->catname) . '/' . $PARENTS->id . '/1/index.html';
        } else {
          $url = '?p=category&amp;cat=' . $PARENTS->id;
        }
        $q_children = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                      WHERE `enCat` = 'yes'
                      AND `childOf` = '{$PARENTS->id}'
                      ORDER BY `catname`
                      LIMIT ".SUB_CATEGORY_DISPLAY_COUNT."
                      ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
        if (mysqli_num_rows($q_children)>0) {
          $theChildren = categories::children($PARENTS->id);
        }
        while ($CHILDREN = mysqli_fetch_object($q_children)) {
          if ($s->modr=='yes') {
            $curl = $s->install_path . 'category/' . _mmURL($PARENTS->catname) . '/' . _mmURL($CHILDREN->catname) . '/' . $CHILDREN->id . '/1/index.html';
          } else {
            $curl = '?p=category&amp;cat=' . $CHILDREN->id;
          }
          $children .= '<a href="' . $curl . '">' . _mmClean($CHILDREN->catname) . '</a>' . (SHOW_CATEGORY_RECIPE_COUNT ? ' (' . _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category = \'' . $CHILDREN->id . '\'').')' : '') . (++$ccount!=mysqli_num_rows($q_children) ? ', ' : (SUB_CATEGORY_DISPLAY_COUNT>mysqli_num_rows($q_children) ? '' : '...'));
        }
        $right .= str_replace(
          array('{url}','{parent}','{children}','{count}'),
          array($url,_mmClean($PARENTS->catname),($children ? '<span class="children">'.$children.'</span>' : ''),(SHOW_CATEGORY_RECIPE_COUNT ? ' ('.(PARENT_WITH_CHILD_COUNT ? _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category = \'' . $PARENTS->id . '\'')+(!empty($theChildren) ? _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category IN (' . implode(',',$theChildren) . ')') : 0) : _mmSQLRows('recipes LEFT JOIN ' . DB_PREFIX . 'recipe_cats ON ' . DB_PREFIX . 'recipes.id = ' . DB_PREFIX . 'recipe_cats.recipe',' WHERE enRecipe = \'yes\' AND isApproved = \'no\' AND ' . DB_PREFIX . 'recipe_cats.category = \'' . $PARENTS->id . '\'')) . ')' : '')),
          file_get_contents(PATH . 'content/html/categories-list.htm')
        );
      }
    }
    return ['left' => $left, 'right' => $right];
  }

  // Displays most popular recipes for category group when viewing a category..
  public static function category_group_popular($cat,$s = null) {
    $string = '';
    $ids    = categories::category_assoc($cat,false);
    if (!empty($ids)) {
      $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT *,`" . DB_PREFIX . "recipes`.`id` AS `recipeID` FROM `" . DB_PREFIX . "recipes`
              LEFT JOIN `" . DB_PREFIX . "recipe_cats`
              ON `" . DB_PREFIX . "recipes`.`id` = `" . DB_PREFIX . "recipe_cats`.`recipe`
              WHERE `enRecipe`  = 'yes'
              AND `isApproved`  = 'no'
              AND `" . DB_PREFIX . "recipe_cats`.`category` IN (" . implode(',', $ids) . ")
              GROUP BY `" . DB_PREFIX . "recipe_cats`.`recipe`
              ORDER BY `hits` DESC,`name`
              LIMIT " . MOST_POPULAR_DISPLAY_LIMIT
              ) or die(mysqli_error($GLOBALS["___mysqli_ston"]));
      while ($RECIPES = mysqli_fetch_object($query)) {
        // Build link data..
        if ($s->modr=='yes') {
          $link  = $s->install_path . 'free-recipe/' . _mmURL($RECIPES->name) . '/' . $RECIPES->recipeID . '/index.html';
        } else {
          $link  = $s->install_path . '?p=recipe&amp;recipe=' . $RECIPES->recipeID;
        }
        // Chef link
        if ($s->modr=='yes') {
          $chef_url = $s->install_path . 'search-free-recipes/chef::' . urlencode($RECIPES->submitted_by) . '/' . (isset($_GET['cat']) && $_GET['cat'] > 0 ? (int) $_GET['cat'] : 'all') . '/1/index.html';
        } else {
          $chef_url = '?p=search-free-recipes&amp;keys=chef::' . urlencode($RECIPES->submitted_by) . (isset($_GET['cat']) && $_GET['cat'] > 0 ? '&amp;cat=' . (int) $_GET['cat'] : '&amp;cat=all');
        }
        // Get image
        $q_pic = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "pictures`
                WHERE `recipe` = '{$RECIPES->recipeID}'
                ORDER BY `id`
                LIMIT 1
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
        $PIC = mysqli_fetch_object($q_pic);
        $image = 'content/images/placeholder.png';
        if (isset($PIC->picPath) && file_exists(PATH . 'content/images/recipes/' . $PIC->picPath)) {
          $image = 'content/images/recipes/' . $PIC->picPath;
        }
        $string .= str_replace(
          array('{link}','{recipe}','{image}','{cheflink}','{chef}'),
          array($link,_mmHTML($RECIPES->name),$image,$chef_url,_mmHTML($RECIPES->submitted_by)),
          file_get_contents(PATH.'content/html/latest-popular-link.htm')
        );
      }
    }
    return $string;
  }

  // Get id numbers of categories associated to current category..
  private static function category_assoc($cat,$skip=true) {
    $ids = [];
    // Get cat data..
    $CAT = _mmSQLTable('categories','id',$cat);
    // Is category parent..
    if ($CAT->isParent=='no') {
      $thisParent = _mmSQLTable('categories','id',$CAT->childOf);
      $ids[]      = $thisParent->id;
    }
    if (isset($thisParent->catname)) {
      $q_cats = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                WHERE `enCat`    = 'yes'
                AND   `childOf`  = '{$thisParent->id}'
                ORDER BY `isParent` DESC,`catname`
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    } else {
      $q_cats = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                WHERE `enCat`  = 'yes'
                AND (`id`      = '{$cat}'
                OR `childOf`   = '{$cat}')
                ORDER BY `isParent` DESC,`catname`
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    }
    while ($CATS = mysqli_fetch_object($q_cats)) {
      if ($skip) {
        if ($CATS->id!=$cat) {
          $ids[] = $CATS->id;
        }
      } else {
        $ids[] = $CATS->id;
      }
    }
    return $ids;
  }

  // Shows related category list..
  public static function categories_related($cat,$parent=[],$s = null) {
    global $ps_category9;
    $string = '';
    $ids    = categories::category_assoc($cat);
    if (!empty($ids)) {
      $catList = array_merge($ids, [$cat]);
      $recipes = [];
      $q_cats = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
                WHERE `id` IN (" . implode(',', $catList) . ")
                AND `id` != '{$cat}'
                ORDER BY `catname`
                ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
      while ($CATS = mysqli_fetch_object($q_cats)) {
        if ($s->modr=='yes') {
          if (isset($parent->catname)) {
            $link = $s->install_path . 'category/' . _mmURL($parent->catname) . '/' . _mmURL($CATS->catname) . '/' . $CATS->id . '/1/index.html';
          } else {
            $link = $s->install_path . 'category/' . _mmURL($CATS->catname) . '/' . $CATS->id . '/1/index.html';
          }
        } else {
          $link = '?p=category&amp;cat=' . $CATS->id;
        }
        $string .= str_replace(
          array('{link}','{cat}'),
          array($link,_mmClean($CATS->catname)),
          file_get_contents(PATH.'content/html/related-categories.htm')
        );
      }
    }
    return ($string ? $string : $ps_category9);
  }

  public static function category_names($ids = [], $del = ',') {
    $cats = [];
    $q = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `" . DB_PREFIX . "categories`
        WHERE `id` IN(" . (!empty($ids) ? implode($del, $ids) : '0')  . ")
        ORDER BY `catname`
        ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    while($C = mysqli_fetch_object($q)) {
      $parent = '';
      if ($C->childOf > 0) {
        $PAR = _mmSQLTable('categories','id', $C->childOf);
        $parent = ' (' . $PAR->catname . ')';
      }
      $cats[] = $C->catname . $parent;
    }
    return $cats;
  }

}

?>
