<?php

/* CLASS FILE
----------------------------------*/

class rss {

  const xml_version  = '1.0';
  const encoding     = 'utf-8';
  const rss_version  = '2.0';

  // Build category RSS link..
  public static function rss_cat_link($id,$s = null) {
    global $ps_header10;
    $rss = '';
    if ($s->enRSS=='yes') {
      $rss = '<a href="'.($s->modr=='yes' ? $s->install_path.'rss-cat-feed/'.$id.'/index.html' : '?p=rss-cat-feed&amp;cat='.$id).'" title="">' . $ps_header10 . '</a>';
    }
    return $rss;
  }

  // Get latest recipes..
  public static function rss_latest_recipes($build_date,$cat=0,$s = null) {
    global $msg_rss3,$ps_recipe34;
    $string = '';
    $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT *,`" . DB_PREFIX . "recipes`.`id` AS `recipeID` FROM `" . DB_PREFIX . "recipes`
            LEFT JOIN `" . DB_PREFIX . "recipe_cats` ON `" . DB_PREFIX . "recipes`.`id` = `" . DB_PREFIX . "recipe_cats`.`recipe`
            WHERE `enRecipe`  = 'yes'
            AND `isApproved`  = 'no'
            ".($cat>0 ? 'AND `' . DB_PREFIX . 'recipe_cats`.`category` = \''.$cat.'\'' : '')."
            GROUP BY `" . DB_PREFIX . "recipe_cats`.`recipe`
            ORDER BY `" . DB_PREFIX . "recipes`.`id` DESC
            LIMIT ".RSS_FEED_LIMIT."
            ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
    while ($RSS = mysqli_fetch_object($query)) {
      $string .= rss::rss_item(
        $msg_rss3.$RSS->name,
        ($s->modr=='yes' ? $s->install_path.'free-recipe/'._mmURL($RSS->name).'/'.$RSS->recipeID.'/index.html' : $s->install_path.'index.php?p=recipe&amp;recipe='.$RSS->recipeID),
        ($RSS->rss_date ? $RSS->rss_date : $build_date),
        $ps_recipe34.' '.($RSS->submitted_by ? $RSS->submitted_by : 'N/A')
      );
    }
    return trim($string);
  }

  // Starts RSS Channel..
  public static function rss_open_channel() {
    $xml   = '<rss version="' . self::xml_version . '" xmlns:atom="http://www.w3.org/2005/Atom">' . _mmNL() . '<channel>' . _mmNL();
    $xml2  = '<?xml version="' . self::xml_version . '" encoding="' . self::encoding . '" ?>' . _mmNL();
    return trim($xml2 . $xml);
  }

  // Loads data into Feed..
  public static function rss_item($title='',$link='',$date='',$desc='') {
    $xml_string = '
    <item>
    <title>'.rss::rss_render($title).'</title>
    <link>'.$link.'</link>
    <pubDate>'.$date.'</pubDate>
    <guid>'.$link.'</guid>
    <description>'.rss::rss_render($desc,false).'</description>
    </item>
    ';

    return $xml_string;
  }

  // Loads Feed Info..
  public static function rss_feed_info($title='',$link='',$date='',$desc='',$site='',$url='') {
    $xml_string = '
    <title>'._mmClean($title, true).'</title>
    <link>'.$link.'</link>
    <description>'._mmClean($desc, true).'</description>
    <lastBuildDate>'.$date.'</lastBuildDate>
    <language>en-us</language>
    <generator>'.rss::rss_render($site).'</generator>
    <atom:link href="'.$url.'" rel="self" type="application/rss+xml" />
    ';

    return $xml_string;
  }

  // Closes RSS Channel..
  public static function rss_close_channel() {
    $xml_string = '
    </channel>
    </rss>
    ';

    return $xml_string;
  }

  // Renders Feed Data..
  public static function rss_render($data,$clean_tags=false) {
    if ($clean_tags) {
      $data = rss::rss_remove_tags($data);
    }

    return '<![CDATA['._mmClean($data, true).']]>';
  }

  // Removes certain tags from feed..
  public static function rss_remove_tags($data) {
    $data =  strip_tags((string) $data,'<b><strong><p><br><img><i><a><u>');
    // Clean foreign characters..
    return _mmURL($data,true);
  }

}

?>
