<?php

/* CLASS FILE
----------------------------------*/

class tags {

  // List of allowed tags for WYSIWYG content display
  // Leave empty to allow all tags (not recommended)
  const ALLOWED_TAGS = [
    '<p>','<blockquote>','<h1>','<span>','<h2>','<h3>','<h4>',
    '<b>','<br>','<i>','<strike>','<sup>','<sub>','<a>','<img>',
    '<ul>','<li>','<ol>','<div>','<iframe>'
  ];

  private static function allowed() {
    // 7.4 or higher supports arrays
    if (version_compare(PHP_VERSION, '7.4.0') >= 0) {
      return tags::ALLOWED_TAGS;
    } else {
      return (!empty(tags::ALLOWED_TAGS) ? implode('', tags::ALLOWED_TAGS) : '');
    }
  }

  public static function filter($data) {
    return strip_tags((string) $data, tags::allowed());
  }

}

?>