<?php

/* Various functions
--------------------------------------*/

function _mmToken() {
  return (function_exists('openssl_random_pseudo_bytes') && function_exists('bin2hex') ?
    bin2hex(openssl_random_pseudo_bytes(50)) :
    substr(sha1(uniqid(rand(),1)), 3 , 35) . substr(sha1(uniqid(rand(),1)), 3 , 45)
  );
}

function getRecCats($id) {
  $cats = [];
  $q = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT `category` FROM `" . DB_PREFIX . "recipe_cats`
       WHERE `recipe` = '{$id}'
       ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
  while($C = mysqli_fetch_object($q)) {
    $cats[] = $C->category;
  }
  return $cats;
}

function _mmEmail($em) {
  if (!is_string($em) || $em == '') {
    return false;
  } else {
    if (function_exists('filter_var') && !filter_var($em, FILTER_VALIDATE_EMAIL)) {
      return false;
    } else {
      // HTML5 spec..
      if (!preg_match('/^[a-zA-Z0-9.!#$%&\'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}' .
        '[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/sD', $em)) {
        return false;
      }
    }
  }
  return true;
}

// Converts recipe/category name for search engine friendly urls..
function _mmURL($title,$cleanrss=false) {
  // Convert special characters from European countries into the English alphabetic equivalent..
  $chars = array(
    chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
    chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
    chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
    chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
    chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
    chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
    chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
    chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
    chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
    chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
    chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
    chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
    chr(195).chr(156) => 'U', chr(195).chr(157) => 'Y',
    chr(195).chr(159) => 's', chr(195).chr(160) => 'a',
    chr(195).chr(161) => 'a', chr(195).chr(162) => 'a',
    chr(195).chr(163) => 'a', chr(195).chr(164) => 'a',
    chr(195).chr(165) => 'a', chr(195).chr(167) => 'c',
    chr(195).chr(168) => 'e', chr(195).chr(169) => 'e',
    chr(195).chr(170) => 'e', chr(195).chr(171) => 'e',
    chr(195).chr(172) => 'i', chr(195).chr(173) => 'i',
    chr(195).chr(174) => 'i', chr(195).chr(175) => 'i',
    chr(195).chr(177) => 'n', chr(195).chr(178) => 'o',
    chr(195).chr(179) => 'o', chr(195).chr(180) => 'o',
    chr(195).chr(181) => 'o', chr(195).chr(182) => 'o',
    chr(195).chr(182) => 'o', chr(195).chr(185) => 'u',
    chr(195).chr(186) => 'u', chr(195).chr(187) => 'u',
    chr(195).chr(188) => 'u', chr(195).chr(189) => 'y',
    chr(195).chr(191) => 'y'
  );

  // Replace chars in array..
  $title = strtr($title, $chars);
  // Are we cleaning RSS output..
  if ($cleanrss) {
    return $title;
  }
  // Strip none alphabetic and none numeric chars..
  $title = strtolower(preg_replace('`[^\w_-]`', '-', $title));
  // Replace other data that may be passed, such as double hyphens..
  return str_replace(array('--','---','----','-amp-','-039-'),
    array('-','-','-','-and-',''),
    $title
  );
}

// Build contact captcha..
function _mmCaptcha($txt,$txt2,$load='',$s = null) {
  $captcha = '';
  if ($s->enSpam=='yes') {
    $captcha = str_replace(array('{captcha_txt}','{enter_word}'),
      array($txt,_mmHTML($txt2)),
      file_get_contents(PATH.'content/html/captcha' . ($load ? '-' . $load : '') . '.htm')
    );
  }
  return $captcha;
}

// Help tip..
function _mmTip($text) {
  if (!HELP_TIPS) {
    return '';
  }
  global $jsvars5;
  $html = '<div class="toolTip">'.$text.'</div>';
  return '';
}

// Returns encrypted data..
function _mmEncrypt($data) {
  if ($data == '') {
    $data = '';
  }
  return (function_exists('sha1') ? sha1($data) : md5($data));
}

// Prepares date for safe mysql import..
function _mmSQLSafe($data) {
  if ($data == '') {
    $data = '';
  }
  return mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $data);
}

// File size conversion..
function _mmFileConv($size=0, $precision = 2) {
  if ($size > 0) {
    $base     = log($size) / log(1024);
    $suffixes = [
      'Bytes',
      'KB',
      'MB',
      'GB',
      'TB'
    ];
    return round(pow(1024, $base - floor($base)), $precision) . $suffixes[floor($base)];
  } else {
    return '0Bytes';
  }
}

// Check digit var..
function _mmDigit($id) {
  global $script21;
  if (!ctype_digit($id) || (int) $id == 0) {
    header("HTTP/1.0 404 Not Found");
    echo '<h1>'.$script21.'</h1>';
    exit;
  }
}

// Gets data based on param criteria..
function _mmSQLTable($table,$row,$id,$and='') {
  if ($table=='recipes') {
    $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT *,DATE_FORMAT(`addDate`,'".MYSQL_DATE_FORMAT."') AS `adate` FROM `".DB_PREFIX.$table."`
             WHERE `$row`  = '{$id}'
             $and
             LIMIT 1
             ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
  } else {
    $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `".DB_PREFIX.$table."`
             WHERE `$row`  = '{$id}'
             $and
             LIMIT 1
             ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));
  }
  return mysqli_fetch_object($query);
}

// Gets row count..
function _mmSQLRows($table,$where='') {
  $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT count(*) AS `r_count` FROM ".DB_PREFIX.$table.' '.$where."")
           or die(mysqli_error($GLOBALS["___mysqli_ston"]));
  $row = mysqli_fetch_object($query);
  return str_replace(',','',$row->r_count);
}

function _mmClean($data, $amp = false) {
  if ($data == '') {
    $data = '';
  }
  if ($amp) {
    $data = str_replace([' & '],[' &amp; '],$data);
  }
  return ($data ? trim($data) : '');
}

function mmSafeJS($data) {
  if ($data == '') {
    $data = '';
  }
  return trim(str_replace("'","\'",$data));
}

function _mmHTML($data) {
  if ($data == '') {
    $data = '';
  }
  return htmlspecialchars(trim($data));
}

// Gets visitor IP address..
function _mmIP() {
  $ips = [];
  $types = array(
    'HTTP_CLIENT_IP',
    'HTTP_X_FORWARDED_FOR',
    'HTTP_X_FORWARDED',
    'HTTP_X_CLUSTER_CLIENT_IP',
    'HTTP_FORWARDED_FOR',
    'HTTP_FORWARDED',
    'REMOTE_ADDR'
  );
  foreach ($types AS $key) {
    if (array_key_exists($key, $_SERVER) === true) {
      foreach (array_map('trim', explode(',', $_SERVER[$key])) AS $ipA) {
        if (!in_array($ipA, $ips) && filter_var($ipA, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE) !== false) {
          $ips[] = $ipA;
        } else {
          // Double check for localhost..
          if (!in_array($ipA, $ips) && in_array($ipA, array('::1','127.0.0.1'))) {
            $ips[] = $ipA;
          }
        }
      }
    }
  }
  return (!empty($ips) ? implode(',', $ips) : '');
}

// Define newline..
function _mmNL($br = 1) {
  if ($br > 1) {
    return str_repeat(PHP_EOL, $br);
  }
  return PHP_EOL;
}

// Recursive way of handling multi dimensional arrays..
// This cleans query string data and prevents code injections..
function _mmMDAM($func,$arr) {
  $newArr = [];
  if (!empty($arr)) {
    foreach($arr AS $key => $value) {
      $newArr[$key] = (is_array($value) ? _mmMDAM($func,$value) : $func($value));
    }
  }
  return $newArr;
}

function mmHash($d = []) {
  switch($d['type']) {
    case 'add':
      return password_hash($d['pass'], PASSWORD_BCRYPT);
      break;
    case 'calc':
      return password_verify($d['val'], $d['hash']);
      break;
  }
}

// Clear query string array input..
$_GET  = _mmMDAM('_mmHTML', $_GET);

?>