<?php

/* ADDITIONAL OPTIONS
   These options are provided as an easy way to change additional
   settings in the system. Most are detailed on the F.A.Q page in the docs.

   IMPORTANT!! Edit values on right, DO NOT change values in capitals
============================================================================================*/

/*
  If enabled shows banner rotator
  1 = Enabled, 0 = Disabled
*/
define('EN_BANNER_ROTATOR', 1);

/* Enable adding comments for recipes
   Useful if you want to enable comments, but not have visitors
   submit anything
   1 = Enabled, 0 = Disabled
*/
define('ENABLE_RECIPE_COMMENT_ADDING', 1);

/*
  For recipe picture gallery, add blanks
  1 = Enabled, 0 = Disabled
*/
define('IMG_GALLERY_BLANKS', 1);

/*
  If your setup isn`t displaying the correct time, you may
  have a server in a different location. Set the adjustment in hours here.
  This supports PHP`s strtotime function
  DO NOT change this unless you are familiar with this function
*/
define('SERVER_TIME_ADJUSTMENT', '+0 hours');

/*
  Do you wish to enable the hit count on the recipe page?
  1 = Enabled, 0 = Disabled
*/
define('ENABLE_HIT_COUNT', 1);

/*
  The hit counter can be a minimum amount of digits
  For example, set to 6 the display would start 000001
  If you only want to display the exact count, set this to 0
  Otherwise set a minimum amount of digits
*/
define('HIT_COUNT_DIGITS_MIN', 6);

/*
  How do you want the recipes to display?
  By default this is recipe name ascending (a-z), however you can change the appearance below
  name             = By recipe name Ascendng
  name DESC        = By recipe name Descending
  recipes.id       = By recipe id Ascending
  recipes.id DESC  = By recipe id Descending
*/
define('RECIPE_DISPLAY_ORDER', 'name');

/*
  Some pages display the most popular recipes in the right menu
  How many most popular recipes do you wish to show?
*/
define('MOST_POPULAR_DISPLAY_LIMIT', 10);

/*
  Some pages display the latest recipes in the right menu
  How many most latest recipes do you wish to show?
*/
define('LATEST_RECIPES_DISPLAY_LIMIT', 10);

/*
  How many latest recipes do you wish to show in the RSS feed if enabled?
*/
define('RSS_FEED_LIMIT', 50);

/*
  When viewing a recipe, a link in the right menu shows other recipes in the same category
  How many recipes do you wish to show?
*/
define('OTHER_RECIPES_IN_CAT_DISPLAY_LIMIT', 5);

/*
  The homepage shows the categories/sub categories
  How many sub categories do you want to display beneath each parent category?
  Set to a high number for all
*/
define('SUB_CATEGORY_DISPLAY_COUNT', 10);

/*
  If you enable this, the total amount of recipes is shown next to each category
  on the homepage. ie: Fish (20), Meat (13) etc
  1 = Enabled, 0 = Disabled
*/
define('SHOW_CATEGORY_RECIPE_COUNT', 1);

/*
  Should parent category count also include children recipe count?
  ie: If a parent has 3 recipes and in total the children have 10, this would
  show a count of 13 for the parent
  1 = Enabled, 0 = Disabled
*/
define('PARENT_WITH_CHILD_COUNT', 0);

/*
  On the 'Add Recipe' page. Separator for image size message.
*/
define('IMG_RESTRICTION_SEPERATOR', ', ');

/*
  Do you wish to enable the contact us e-mail auto responder?
  1 = Enabled, 0 = Disabled
*/
define('ENABLE_CONTACT_US_AUTO_RESPONDER', 1);

/*
  Do you wish to enable the add comment e-mail auto responder?
  1 = Enabled, 0 = Disabled
*/
define('ENABLE_COMMENT_AUTO_RESPONDER', 1);

/*
  Do you wish to enable the add recipe e-mail auto responder?
  1 = Enabled, 0 = Disabled
*/
define('ENABLE_RECIPE_AUTO_RESPONDER', 1);

/*
  Default build date for RSS feeds
*/
define('RSS_BUILD_DATE_FORMAT', date('r', strtotime(SERVER_TIME_ADJUSTMENT)));

/*
  Mysql Date format for mysql date display. Converts the YYYY-MM-DD format
  into your preferred format. For more info see:
  http://dev.mysql.com/doc/refman/5.0/en/date-and-time-functions.html
*/
define('MYSQL_DATE_FORMAT', '%e %b %Y');

/*
  Preferred PHP date format
  https://www.php.net/manual/en/datetime.format.php
*/
define('PHP_DATE_FORMAT', 'j F Y');

/*
  Displays the 'Powered by Maian Recipe' link in your browser title bar
  You may disable this if you wish. Note that disabling this does NOT
  alter the page footer text. That should remain.
  1 = Enabled, 0 = Disabled
*/
define('ENABLE_POWERED_BY_LINK', 1);

/*
  How many recipes per page in the admin area
*/
define('PER_PAGE', 30);

/*
  Latest data limits for admin homepage
*/
define('ADMIN_HOME_RECIPES', 5);
define('ADMIN_HOME_COMMENTS', 5);

/*
  If enabled displays help tips in the admin area
  1 = Enabled, 0 = Disabled
*/
define('HELP_TIPS', 1);

/*
  Allowed mime types for images for add recipe submissions
  Add to array if required. Checked via finfo functions.
*/
$allowedMimeTypes = [
  'image/jpeg',
  'image/png',
  'image/gif',
  'image/bmp'
];

?>
